
#ifndef __ACCOUNTMANNAGER_H__
#define __ACCOUNTMANNAGER_H__



#define		MAX_LENGTH		256


//#include <stdio.h>




bool GetComputerNameLocal( LPTSTR &szName, LPTSTR &szError )
{
//Get the machine name
	WORD			wVersionRequested;
	WSADATA			wsaData;
	int				err;
	CHAR			szLocalName[MAX_LENGTH];
	ULONG			dwLen							= MAX_LENGTH;
	
	wVersionRequested = MAKEWORD( 2, 2 );
	
	err = WSAStartup( wVersionRequested, &wsaData );
	if ( err != 0 ) {
		/* Tell the user that we could not find a usable */
		/* WinSock DLL.                                  */
		wcscpy(szError, L"Can't find a usable WinSock DLL");
		return false;
	}

	if(gethostname(szLocalName, dwLen) != NO_ERROR)
    {
		wcscpy(szError, L"Can't gethostname");
		return false;
    }
	
	USES_CONVERSION;

	wcscpy( szName, A2T( szLocalName ) );
	

	WSACleanup();
 
	
	return true;
}

bool GetDomainNameLocal( LPTSTR &szName, LPTSTR &szError )
{
	TCHAR					szDomain[MAX_LENGTH]	={0};
	TCHAR					szComputerName[MAX_LENGTH]	={0};

	LPTSTR 					szDomainMachineName;

	ULONG					dwLen						= MAX_LENGTH;

	//GetComputerName(szDomainName, &dwLen);
	     

	if (!GetComputerNameEx(ComputerNamePhysicalDnsDomain, szDomain ,&dwLen)) //pdc
	{
		LPVOID lpMsgBuf; 
		FormatMessage( 
						FORMAT_MESSAGE_ALLOCATE_BUFFER | 
						FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						(LPTSTR) &lpMsgBuf,
						0,
						NULL 
						);
		// Display the string.
		wsprintf(szError, L"Error in GetDomainNameLocal:  %s", (LPCTSTR)lpMsgBuf);
		// Free the buffer.
		LocalFree( lpMsgBuf );
	}  
	

	NetGetDCName(NULL, NULL, (LPBYTE *)&szDomainMachineName);


	dwLen				= MAX_LENGTH;
	if (!GetComputerNameEx(ComputerNamePhysicalDnsHostname, szComputerName ,&dwLen))
	{
		LPVOID lpMsgBuf; 
		FormatMessage( 
						FORMAT_MESSAGE_ALLOCATE_BUFFER | 
						FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(), 
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						(LPTSTR) &lpMsgBuf,
						0,
						NULL 
						);
		// Display the string.
		wsprintf(szError, L"Error in GetDomainNameLocal:  %s", (LPCTSTR)lpMsgBuf);
		// Free the buffer.
		LocalFree( lpMsgBuf );
		
		return false;
	}
 

	if (_wcsicmp(szComputerName, (szDomainMachineName+2))==0) 
		wcscpy( szName, szDomain );
	else
		wcscpy( szName, szComputerName );


	NetApiBufferFree(szDomain);
	NetApiBufferFree(szComputerName);

	return true; 
}

bool GetDomainName( LPTSTR &szName, LPTSTR &szError )
{
	//Get the domain name
	//NTSTATUS				Status;
	//NET_API_STATUS		nas;
	//TCHAR					szDomainName[MAX_LENGTH];
	LPTSTR					szDomainName				= {0};
	ULONG					dwLen						= MAX_LENGTH;

	// obtain the primary DC computer name from the specified
/*	nas						= NetGetDCName( NULL, NULL, (LPBYTE *)&szDomainName);
	if(nas != NERR_Success) 
	{	// free allocated memory
		NetApiBufferFree(szDomainName);
		szError			= DisplayNtStatus("NetGetDCName", nas);
		return false;
	}
*/
	 
/*	
	if (!GetComputerNameEx(ComputerNameDnsDomain, szDomainName ,&dwLen))
	{
		wcscpy(szError, L"Can't obtain the DomainName");
		return false;
	}


	//MessageBox(NULL, szDomainName, L"DCName", MB_OK); 

	wcscpy( szName, szDomainName );

	// free allocated memory
	NetApiBufferFree(szDomainName);
*/
	return true;
}

bool	AccountCreate( LPTSTR szAccountDefault, LPTSTR szDomainName, LPTSTR szAccountPassword, LPTSTR &szError )
{
	//create an account = szAccountDefault into the domain = szDomainName
	USER_INFO_1			ui;
	DWORD				dwLevel			= 1;
	DWORD				dwError			= 0;
	NET_API_STATUS		nStatus;

	
	wcscpy(szAccountPassword, _wcslwr(szAccountDefault));   
	//MessageBox(NULL, _wcsupr(szAccountDefault), _wcslwr( szName ), MB_OK);

	ui.usri1_name						= _wcsupr(szAccountDefault); //_wcsupr()
	ui.usri1_password					= szAccountPassword;		//_wcslwr
	ui.usri1_priv						= USER_PRIV_USER;			//admin group
	ui.usri1_home_dir					= NULL;
	ui.usri1_comment					= NULL;
	ui.usri1_flags						= UF_SCRIPT;
	ui.usri1_script_path				= NULL;

	//MessageBox(NULL, szAccountDefault, szDomainName, MB_OK); 
	// Call the NetUserAdd function, specifying level 1.
	try
	{
		nStatus = NetUserAdd(	NULL,
								dwLevel,
								(LPBYTE)&ui,
								&dwError); 
		
		if (nStatus != NERR_Success)
		{
			TCHAR		szMsgBuf[256];
			
			switch (nStatus)
			{
			case	ERROR_ACCESS_DENIED:	wcscpy(szMsgBuf, L"The user does not have access to the requested information.");break;
			case	NERR_InvalidComputer:	wcscpy(szMsgBuf, L"The computer name is invalid.");break;
			case	NERR_NotPrimary:		wcscpy(szMsgBuf, L"The operation is allowed only on the primary domain controller of the domain.");break;
			case	NERR_GroupExists:		wcscpy(szMsgBuf, L"The group already exists.");break;
			case	NERR_UserExists:		wcscpy(szMsgBuf, L"The user account already exists.");break;
			case	NERR_PasswordTooShort:	wcscpy(szMsgBuf, L"The password is shorter than required, too long, too recent or not have enough unique characters.");break;
				
			default:						wcscpy(szMsgBuf, L"Unspecified error.");break;
			}
			
			// Display the string.
			swprintf(szError, L"Error in AccountCreate:  %s", szMsgBuf);
			
			return false;
		}
	}
	catch(...)
	{
		wcscpy(szError, L"Error in AccountCreate: Unspecified error.");
		return false;
	}

	return true;
}

bool	AccountInsertInGroup( LPTSTR szAccountDefault, LPTSTR szLocalGroup, LPTSTR &szError )
{
	LOCALGROUP_MEMBERS_INFO_3					localgroup_members;
	NET_API_STATUS								nStatus;

	localgroup_members.lgrmi3_domainandname		= szAccountDefault;

	// Call the NetLocalGroupAddMembers function
	try
	{
		nStatus = NetLocalGroupAddMembers(	NULL,							//server local
											szLocalGroup,					//group name
											3,								//passing in name
											(LPBYTE)&localgroup_members,	// Buffer
											1 );							// count passed in 
		
		if (nStatus != NERR_Success)
		{
			TCHAR		szMsgBuf[256];
			
			switch (nStatus)
			{
			case	ERROR_ACCESS_DENIED:	wcscpy(szMsgBuf, L"The user does not have access to the requested information.");break;
			case	NERR_GroupNotFound :	wcscpy(szMsgBuf, L"The local group specified by the groupname parameter does not exist.");break;
			case	ERROR_NO_SUCH_MEMBER :	wcscpy(szMsgBuf, L"One or more of the members specified do not exist. Therefore, no new members were added.");break;
			case	ERROR_MEMBER_IN_ALIAS:	wcscpy(szMsgBuf, L"One or more of the members specified were already members of the local group. No new members were added.");break;
			case	ERROR_INVALID_MEMBER :	wcscpy(szMsgBuf, L"One or more of the members cannot be added because their account type is invalid. No new members were added.");break;
				
			default:						wcscpy(szMsgBuf, L"Unspecified error.");break;
			}
			
			// Display the string.
			swprintf(szError, L"Error in AccountInsertInGroup:  %s", szMsgBuf);
			
			return false;
		}
	}
	catch(...)
	{
		wcscpy(szError, L"Error in AccountCreate: Unspecified error.");
		return false;
	}

	return true;
}
bool	AccountExist( LPTSTR szAccountDefault, bool &bExist, LPTSTR &szError )
{
	//create an account = szAccountDefault into the domain = szDomainName
	DWORD				dwLevel			= 10;
	LPUSER_INFO_10		pBuf			= NULL;
	NET_API_STATUS		nStatus;

	bExist								= true;

	// Call the NetUserGetInfo function, specifying level 10.
	try
	{
		nStatus = NetUserGetInfo(	NULL,
									szAccountDefault,
									dwLevel,
									(LPBYTE *)&pBuf);

		if (nStatus != NERR_Success)
		{
			TCHAR		szMsgBuf[256];
			
			switch (nStatus)
			{
			case	ERROR_ACCESS_DENIED:	wcscpy(szMsgBuf, L"The user does not have access to the requested information.");break;
			case	NERR_InvalidComputer:	wcscpy(szMsgBuf, L"The computer name is invalid.");break;
			case	NERR_UserNotFound:		wcscpy(szMsgBuf, L"The user name could not be found.");
											bExist	= false;
											return true;
											break;
				
			default:						wcscpy(szMsgBuf, L"Unspecified error.");break;
			}
			
			// Display the string.
			swprintf(szError, L"Error in AccountExist:  %s", szMsgBuf);
			
			return false;
		}
	}
	catch(...)
	{
		wcscpy(szError, L"Error in AccountCreate: Unspecified error.");
		return false;
	}

	return true;
}

bool	AccountDelete( LPTSTR szAccountDefault, LPTSTR &szError )
{
	//create an account = szAccountDefault into the domain = szDomainName
	DWORD dwError = 0;
	NET_API_STATUS nStatus;


	// Call the NetUserDel  function.
	try
	{
		nStatus = NetUserDel(	NULL,	szAccountDefault);

		if (nStatus != NERR_Success)
		{
			TCHAR		szMsgBuf[256];
			
			switch (nStatus)
			{
			case	ERROR_ACCESS_DENIED:	wcscpy(szMsgBuf, L"The user does not have access to the requested information.");break;
			case	NERR_InvalidComputer:	wcscpy(szMsgBuf, L"The computer name is invalid.");break;
			case	NERR_UserNotFound:		wcscpy(szMsgBuf, L"The user name could not be found.");break;
			case	NERR_NotPrimary:		wcscpy(szMsgBuf, L"The operation is allowed only on the primary domain controller of the domain.");break;
				
			default:						wcscpy(szMsgBuf, L"Unspecified error.");break;
			}
			
			// Display the string.
			swprintf(szError, L"Error in AccountExist:  %s", szMsgBuf);
			
			return false;
		}
	}
	catch(...)
	{
		wcscpy(szError, L"Error in AccountCreate: Unspecified error.");
		return false;
	}

	return true;
}



//*********************************************************************************************
//LookupUser 
//management of user account
//
//*********************************************************************************************
int		LookupUser(	LPTSTR &AccountName, LPTSTR &AccountPassword, LPTSTR &szError)
{
    int				iRetVal				= RTN_OK;		// assume error from main
	LPTSTR			szDomainName(L""); 
	LPTSTR			szLocalGroup(L"administrators"); 
	bool			bExist				= true;
	TCHAR			lpszName[1024];
 
 

	if ( wcslen(AccountName)== 0 )
	{
		//must create the user IXNET into local domain

		wcscpy(AccountName, szAccountDefault); 
		
		if ( !GetDomainNameLocal(szDomainName, szError) )					return RTN_ERROR;	
		//if ( !GetComputerNameLocal(szDomainName, szError) )					return RTN_ERROR;
		//if ( !GetDomainName(szDomainName, szError) )						return RTN_ERROR;	
 
		if ( !AccountExist(AccountName, bExist, szError))					return RTN_ERROR;	
		if (bExist)			//account exist
			if ( !AccountDelete(szAccountDefault, szError) )				return RTN_ERROR;	
 		
		//new account
		if ( !AccountCreate(AccountName, szDomainName, AccountPassword, szError) )return RTN_ERROR;
		//insert the new account into the admin local group
		if ( !AccountInsertInGroup(AccountName, szLocalGroup, szError))		return RTN_ERROR;

	}
	else
	{
		//must look for AccountName if it's in the format "domain\account"
		//if is, try to find if the "account" exist in the "domain"
		//if not -> create the account  in the local domain; and save it in regs
		TCHAR		*pdest;
		int			poz;

		//MessageBox(NULL, AccountName, L"", MB_OK);

		pdest		= wcschr( AccountName, '\\' ); 
		poz			= pdest - AccountName;
		if( pdest != NULL )
		{	//find it!
			wcsncpy(szDomainName, AccountName, poz);
			szDomainName[poz]			= '\0';
			wcscpy(AccountName, pdest+1); 
		}
		else
		{
			pdest		= wcschr( AccountName, '/' ); 
			poz			= pdest - AccountName;
			if( pdest != NULL )
			{	//find it!
				wcsncpy(szDomainName, AccountName, poz);
				szDomainName[poz]			= '\0';
				wcscpy(AccountName, pdest+1); 
			}  			
		}		
		//MessageBox(NULL, szDomainName, AccountName, MB_OK);



		if ( wcslen(szDomainName)== 0 )					// no domain given, suppoze is local
			if ( !GetDomainNameLocal(szDomainName, szError) )				return RTN_ERROR;

		if ( _wcsicmp(szDomainName, L"localhost") == 0 )	// localhost, put the localdomain
			if ( !GetDomainNameLocal(szDomainName, szError) )				return RTN_ERROR;

		if ( _wcsicmp(szDomainName, L".") == 0 )	// localhost, put the localdomain
			if ( !GetDomainNameLocal(szDomainName, szError) )				return RTN_ERROR;

		//MessageBox(NULL, szDomainName, AccountName, MB_OK);


     
	   	  
		if ( !AccountExist(AccountName, bExist, szError))					return RTN_ERROR;	
		if (!bExist)			//account not exist
		{ 
			//new account
			//wcscpy(AccountName, szAccountDefault);  

			if ( !AccountExist(AccountName, bExist, szError))				return RTN_ERROR;	
			if (bExist)			//account exist
				if ( !AccountDelete(szAccountDefault, szError) )			return RTN_ERROR;

			if ( !AccountCreate(AccountName, szDomainName,AccountPassword, szError) )		return RTN_ERROR;
		 
			//insert the new account into the admin local group
			if ( !AccountInsertInGroup(AccountName, szLocalGroup, szError))	return RTN_ERROR;
	
		} 
		//account exist
	}


	swprintf(lpszName, L"%s\\%s", szDomainName, AccountName);
	wcscpy(AccountName, lpszName);

	//MessageBox(NULL, szDomainName, AccountName, MB_OK); 

	return			iRetVal;
}



#endif (__ACCOUNTMANNAGER_H__)