// Client.cpp : Implementation of CClient
#include "stdafx.h"
#include "ReplicationClient.h"
#include "Client.h"



#include	"Signals.h"
LPTSTR		m_szMailslotName(L"IXNET");


void   Log(LPTSTR sz)
{ 
	FILE *stream;
	USES_CONVERSION;

	char		szData[1024];
	strcpy(szData, T2A(sz));

	try
	{
		stream = fopen( "c:\\\\temp\\LogReplicationClient.txt", "a+" );
		fwrite( szData, 1, strlen(szData), stream );
		fwrite( "\r\r", 1, strlen("\r\n"), stream );
		 
		fclose( stream );
	}
	catch(...)
	{
	}
}


/////////////////////////////////////////////////////////////////////////////
// CClient

STDMETHODIMP CClient::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IClient
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (::InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

void CClient::MyLock()
{
	EnterCriticalSection(&m_cs);
}

void CClient::MyUnlock()
{
	LeaveCriticalSection(&m_cs);
}


bool CClient::ReadSignals()
{
	//here read signal from server
	//to read	m_szServerName 
		LPTSTR		szError(L"");
		LPTSTR		szMessage(L"");
		szError		= (TCHAR*) malloc( 1024 * sizeof(TCHAR) ); 
		szMessage	= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );

		wcscpy(m_szMessage, L"");
		m_szMessage[0]	= '\0';


		if ( !GetSignals(m_szMailslotName, szMessage, szError) )
		{
			Log(szError);

			free( szError );
			free( szMessage );
			return false; 
		} 
		else 
		{	 
			//Log(szMessage);

			if ( 0 != _wcsicmp(szMessage, L"readvise") )		//we dont have an readvise all
				wcscpy(m_szServerName, szMessage);
			else												//is an readvise all
			{
				wcscpy(m_szMessage, szMessage);
			}

			free( szError );
			free( szMessage );
			return true; 
		}
}


CClient::CClient()
{
	InitializeCriticalSection(&m_cs);
	
	//ReadSettings();
	m_bRunningFirstTime	= TRUE;
	wcscpy(m_szServerName, L"");
	wcscpy(m_szMessage, L"");
	

	m_evtStopThread		= CreateEvent (NULL,			// No security attributes
									TRUE,				// Manual-reset event
									FALSE,				// Initial state is NONsignaled
									TEXT("EventStop"));	// Object name
}


HRESULT CClient::FinalConstruct()
{
	MACROBEGINTRY
		
		
	StartLookupSignals();
	//LaunchObserver();

	
	MACROENDTRY
}

HRESULT CClient::FinalRelease()
{
	MACROBEGINTRY


		if (m_pHandler)
		{
			//unadvise
			m_pHandler->FinalRelease();
			m_pHandler->DispEventUnadvise(m_pUnk);
			m_pHandler->Release();
			//delete m_pHandler
			//m_pUnk->Release();
		}
	
	StopLookupSignals();


	MACROENDTRY
}

bool CClient::LaunchObserver()
{
	HRESULT			hr = S_OK;
	_bstr_t			bstrErrDescription(L"");
	_bstr_t			bstrErrSource(L"");
	_bstr_t			bstrErrMessage(L"");
	TCHAR			szErrMessage[1024];

	try
	{	
		

		COSERVERINFO	psi = { 0, m_szServerName, 0, 0 };
		MULTI_QI		mqi = { &IID_IUnknown, NULL, 0 };
		
		CoInitializeSecurity(NULL, -1, NULL, NULL, RPC_C_AUTHN_LEVEL_NONE, RPC_C_IMP_LEVEL_IMPERSONATE, NULL, EOAC_NONE, NULL);
		
		m_pHandler   = new CEventHandler(this);   
		//hr = CoCreateInstance(CLSID_Server, NULL, CLSCTX_SERVER, IID_IUnknown, (void**)&m_pUnk);
		hr  = CoCreateInstanceEx(	CLSID_Server,
			NULL,
			CLSCTX_SERVER,
			&psi,
			1,
			&mqi  );
		
		if (FAILED(hr) )			return false;
		
		hr  = mqi.hr;
		if (FAILED(hr))				return false;
		
		m_pUnk = (IUnknown*)mqi.pItf;
		
		//advise
		m_pHandler->DispEventAdvise(m_pUnk);
	}
	catch(_com_error err)											
	{				
		//failure
		_bstr_t				bstr(L"");
		
		bstrErrDescription	= err.Description();						
		bstrErrSource		= err.Source();
		wcscpy(szErrMessage	, err.ErrorMessage());
		bstrErrMessage		= szErrMessage;
		
		bstr				+= L" Description = "	+	bstrErrDescription;
		bstr				+= L" Source = "		+	bstrErrSource;
		bstr				+= L" ErrMessage = "	+	bstrErrMessage;
		
		//MessageBox(NULL, L"CoCreateInstance", bstr, MB_OK);
		
		hr = err.Error();	 
		return false;
	}
	
	return true;
}

static DWORD WINAPI WorkerThreadLookupSignals( LPVOID pParam )
{

	SCarry			*pcarry			= (SCarry*)pParam;
	CClient			*pObject		= (CClient*)pcarry->pClass;


	pObject->LookupSignals();

	delete pcarry;
    return 0;   // thread completed successfully
}
void	CClient::LookupSignals()
{
	#define NBHANDLES	1
	HANDLE handles[NBHANDLES]=	{	//(HANDLE) m_evtNotification,
									(HANDLE) m_evtStopThread 
								};

	//MessageBox(NULL, L"LookupSignals", L"", MB_OK);
	static		TCHAR	szServerNameTemp[1024];

	DWORD dwWait; 
	while ( m_bContinueToRun )
	{
		//Beep(200, 200); 
		// wait in  a read operation on mailslot for server to write something
		if ( ReadSignals() )
		{
			//Beep(200, 200); 

			if ( _wcsicmp(m_szMessage, L"readvise") == 0 )			//a readvise all message
			{
				if (wcslen(m_szServerName) > 0 )
				{
					Log(L"readvise");

					Unadvise(); 
					Readvise();
				} 
			}

			if (TRUE	== m_bRunningFirstTime)
			{
				wcscpy(szServerNameTemp, m_szServerName);
				Readvise();
				LaunchObserver();
				m_bRunningFirstTime		= FALSE;
			}
			else
			{
				//if the server name was changed->
				if ( _wcsicmp(szServerNameTemp, m_szServerName) != 0 )
				{
					wcscpy(szServerNameTemp, m_szServerName);
					Unadvise();
					Readvise();
				}
			}
		}
		else
		{
			//Beep(800,200);
			//Log("The server is down.");
		}
		

		dwWait		= WaitForMultipleObjects(NBHANDLES, handles, FALSE, 1 * 10);
		if( dwWait == WAIT_FAILED )
			continue;

		if( dwWait >= WAIT_OBJECT_0 && dwWait <= WAIT_OBJECT_0+NBHANDLES-1 )
		{
			if ( dwWait == WAIT_OBJECT_0 + 1)
				break;	// stop the thread..
			else
			{
				// notification..
			}
		}
		else
		{			// abandonned ..
		}

	}
}
void	CClient::StartLookupSignals()
{
	m_bContinueToRun	=TRUE;
	ResetEvent(m_evtStopThread);


	SCarry		*pcarry		= new SCarry;
	pcarry->bstrName		= L"";
	pcarry->bstrValue		= L""; 
	pcarry->pClass			= this;
	
	//create a new thread to made an asyncronous call
	m_hThread			 = CreateThread(NULL, 0, WorkerThreadLookupSignals, pcarry, 0, &m_ThreadId );
}
void	CClient::StopLookupSignals()
{
	m_bContinueToRun	=FALSE;
	SetEvent(m_evtStopThread);

	WaitForSingleObject( m_hThread, 10000 );
	::TerminateThread(m_hThread, 98765321);
}



bool CClient::Readvise() 
{
	HRESULT			hr = S_OK;
	
	try
	{	
		
		COSERVERINFO	psi = { 0, m_szServerName, 0, 0 };
		MULTI_QI		mqi = { &IID_IUnknown, NULL, 0 };
		
		hr  = CoCreateInstanceEx( CLSID_Server,
			NULL,
			CLSCTX_SERVER,
			&psi,
			1,
			&mqi  );
		
		//hr	= CoCreateInstance(CLSID_Server, NULL, CLSCTX_ALL, IID_IUnknown, (void**)&m_pUnk);
		if (FAILED(hr))		return false;
		
		hr  = mqi.hr;
		if (FAILED(hr))		return false;
		
		m_pUnk = (IUnknown*)mqi.pItf;
		
		//advise
		if (m_pHandler)
			m_pHandler->DispEventAdvise(m_pUnk);
		
	}
	catch(_com_error err)
	{
		hr = err.Error();
		return false;
	}

	if(FAILED(hr))														
		return false;													
	else																
		return true;
}

bool CClient::Unadvise() 
{
	HRESULT			hr = S_OK;
	
	try
	{	
		
		COSERVERINFO	psi = { 0, m_szServerName, 0, 0 };
		MULTI_QI		mqi = { &IID_IUnknown, NULL, 0 };
		
		hr  = CoCreateInstanceEx( CLSID_Server,
			NULL,
			CLSCTX_SERVER,
			&psi,
			1,
			&mqi  );
		
		//hr	= CoCreateInstance(CLSID_Server, NULL, CLSCTX_ALL, IID_IUnknown, (void**)&m_pUnk);
		if (FAILED(hr))		return false;
		
		hr  = mqi.hr;
		if (FAILED(hr))		return false;
		
		m_pUnk = (IUnknown*)mqi.pItf;
		
		//advise
		if (m_pHandler)
			m_pHandler->DispEventUnadvise(m_pUnk);
		
	}
	catch(_com_error err)
	{
		hr = err.Error();
		return false;
	}

	if(FAILED(hr))														
		return false;													
	else																
		return true;
}
bool CClient::ComPing()
{
	// TODO: Add your implementation code here
	HRESULT			hr = S_OK;
	_bstr_t			bstrErrDescription(L"");
	_bstr_t			bstrErrSource(L"");
	_bstr_t			bstrErrMessage(L"");
	TCHAR			szErrMessage[1024];
	
	//CComPtr<IServer>				pItf;
	IServerPtr				pItf;
	//IUnknownPtr				pItf;

	try
	{	
		
		COSERVERINFO		psi = { 0, m_szServerName, 0, 0 };
		MULTI_QI			mqi = { &IID_IServer, NULL, 0 };
		//MULTI_QI			mqi = { &IID_IUnknown, NULL, 0 };
 
		 hr  = CoCreateInstanceEx( CLSID_Server,
				 NULL,
				 CLSCTX_SERVER,
				 &psi,
				 1,
				 &mqi  ); 
 
		//hr	= CoCreateInstance(CLSID_Server, NULL, CLSCTX_ALL, IID_IUnknown, (void**)&pUnk);	
		
		//hr ok or not ??
		if (FAILED(hr) )			return false;
		

		hr  = mqi.hr;
		if (FAILED(hr))				return false;
		
		pItf = (IServer*)mqi.pItf;
		//pItf = (IUnknown*)mqi.pItf;
			  
		if (pItf == NULL)			return false;
		
		
		long				lServiceRun		= 0;
		//pItf->PutResource(L"ATL");
		pItf->Talk(&lServiceRun);
 
		TCHAR				sz[10];
	 
		_ltow( lServiceRun, sz, 10 );
		//MessageBox(NULL, sz, L"CLIENT", MB_OK);
		
		if ( lServiceRun == 0)		return false;
		


		if (pItf) 
		{
			pItf->Release();
			pItf	= NULL;
		}
	}
	catch(_com_error err)											
	{				
		//failure
		_bstr_t				bstr(L"");

		bstrErrDescription	= err.Description();						
		bstrErrSource		= err.Source();
		wcscpy(szErrMessage	, err.ErrorMessage());
		bstrErrMessage		= szErrMessage;

		bstr				+= L" Description = "	+	bstrErrDescription;
		bstr				+= L" Source = "		+	bstrErrSource;
		bstr				+= L" ErrMessage = "	+	bstrErrMessage;

		//MessageBox(NULL, L"CoCreateInstance", bstr, MB_OK);
		Log(bstr);

		hr = err.Error();	 
		return false;
	}

	return true;
}


_bstr_t	CClient::GetServerName()
{
	return	m_szServerName;
}

#define MAX_LENGTH 256

_bstr_t	CClient::GetClientName()
{
	if (wcslen(m_szClientName) > 0 )
	{
		return	m_szClientName;
	}
	else
	{	
		//Get the machine name
		WORD			wVersionRequested;
		WSADATA			wsaData;
		int				err;
		CHAR			szLocalName[MAX_LENGTH];
		ULONG			dwLen							= MAX_LENGTH;
		
		wVersionRequested = MAKEWORD( 2, 2 );
		
		err = WSAStartup( wVersionRequested, &wsaData );
		if ( err != 0 ) {
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			//wcscpy(szError, L"Can't find a usable WinSock DLL");
			return L"";
		}
		
		if(gethostname(szLocalName, dwLen) != NO_ERROR)
		{
			//wcscpy(szError, L"Can't gethostname");
			return L"";
		}
		
		USES_CONVERSION;
		
		wcscpy( m_szClientName, A2T( szLocalName ) );
		
		WSACleanup();
	}

	return	m_szClientName;
}



void CClient::Tell2Server(LPTSTR szPathLocal, LPTSTR szPathServer)
{
	HRESULT			hr = S_OK;
	_bstr_t			bstrErrDescription(L"");
	_bstr_t			bstrErrSource(L"");
	_bstr_t			bstrErrMessage(L"");
	TCHAR			szErrMessage[1024];
	
	_bstr_t			bstrMessage(L"");
	//CComPtr<IServer>				pItf;
	IServerPtr				pItf;

	//swprintf(szMessage, L"<namelocal>%s</namelocal><pathlocal>%s</pathlocal><nameserver>%s</nameserver><pathserver>%s</pathserver>", (LPTSTR)GetClientName(), (LPTSTR)szPathLocal, (LPTSTR)GetServerName, (LPTSTR)szPathServer );
	bstrMessage		= "<namelocal>";
	bstrMessage		+= GetClientName();
	bstrMessage		+= "</namelocal>";
	bstrMessage		+= L"\r\n";

	bstrMessage		+= "<pathlocal>";
	bstrMessage		+= szPathLocal;
	bstrMessage		+= "</pathlocal>";
	bstrMessage		+= L"\r\n";

	bstrMessage		+= "<nameserver>";
	bstrMessage		+= GetServerName();
	bstrMessage		+= "</nameserver>";
	bstrMessage		+= L"\r\n";

	bstrMessage		+= "<pathserver>";
	bstrMessage		+= szPathServer;
	bstrMessage		+= "</pathserver>";
	bstrMessage		+= L"\r\n";

	bstrMessage		+= "<localaccount>"; 
	bstrMessage		+= _Module.m_szAccountName;
	bstrMessage		+= "</localaccount>";
	bstrMessage		+= L"\r\n";


	Log(bstrMessage);

	try
	{	
		
		COSERVERINFO		psi = { 0, m_szServerName, 0, 0 };
		MULTI_QI			mqi = { &IID_IServer, NULL, 0 };
 
		 hr  = CoCreateInstanceEx( CLSID_Server,
				 NULL,
				 CLSCTX_SERVER,
				 &psi,
				 1,
				 &mqi  ); 
		
		//hr ok or not ??
		if (FAILED(hr) )			return;
		
		hr  = mqi.hr;
		if (FAILED(hr))				return;
		
		pItf = (IServer*)mqi.pItf;		  
		if (pItf == NULL)			return;
		
		
		pItf->PutClientName(bstrMessage);


		if (pItf) 
		{
			pItf->Release();
			pItf	= NULL;
		}
	}
	catch(_com_error err)											
	{				
		//failure
		_bstr_t				bstr(L"");

		bstrErrDescription	= err.Description();						
		bstrErrSource		= err.Source();
		wcscpy(szErrMessage	, err.ErrorMessage());
		bstrErrMessage		= szErrMessage;

		bstr				+= L" Description = "	+	bstrErrDescription;
		bstr				+= L" Source = "		+	bstrErrSource;
		bstr				+= L" ErrMessage = "	+	bstrErrMessage;

		hr = err.Error();	 
		return ;
	}

	return;
}


static DWORD WINAPI WorkerThreadReadviseAll( LPVOID pParam )
{

	SCarry				*pcarry			= (SCarry*)pParam;
	CClient				*pObject		= (CClient*)pcarry->pClass;


	pObject->ReadviseAll();

	delete pcarry;
    return 0;   // thread completed successfully
}


void CClient::ReadviseAllLauncher()
{

	SCarry		*pcarry		= new SCarry;
	pcarry->bstrName		= L"";
	pcarry->bstrValue		= L""; 
	pcarry->pClass			= this;
	
	//create a new thread to made an asyncronous call
	CreateThread(NULL, 0, WorkerThreadReadviseAll, pcarry, 0, NULL );
}

void CClient::ReadviseAll()
{
	//here write signal to all mailslot
	//to write readvise message
	Log(L"PutSignalReadviseAll");


	LPTSTR		szError(L"");
	szError		= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );
	if ( !PutSignalReadvise(m_szMailslotName, szError) )
	{
		//log here
		Log(szError);
	}
	free( szError );
}