// EventHandler.cpp: implementation of the CEventHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ReplicationClient.h"
#include "EventHandler.h"



#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include "Client.h"
#include <stdio.h>
#include "..\Include\RegistryInf.h"


void   Log(LPSTR szData)
{
	FILE *stream;

	try
	{
		stream = fopen( "c:\\\\temp\\LogReplicationClient.txt", "a+" );
		fwrite( szData, 1, strlen(szData), stream );
		fwrite( "\n\r", 1, strlen("\r\n"), stream );
		 
		fclose( stream );
	}
	catch(...)
	{
	}
}



void CEventHandler::ReadSettingsPaths() 
{
	USES_CONVERSION;
	//________________________________________________________________________________________________________
	//read settings from regs
	RegistryInf				mRegistryReadObj;
	
 
	_bstr_t					bstrPathServer(mRegistryReadObj.GetKeyValue(L"SOFTWARE\\Articles\\Replication Directory\\AdminServer", L"COFilesPath"));
	wcscpy(szPathServer, (LPCTSTR)bstrPathServer);
	//MessageBox(NULL, szPathServer, bstrPathServer, MB_OK); 
	//Log(T2A(bstrPathServer));
	//wsprintf(szPathServer, L"%s:%d", (LPCTSTR)bstrPathServer, wcslen(bstrPathServer)); 
	

	_bstr_t					bstrPathLocal(mRegistryReadObj.GetKeyValue(L"SOFTWARE\\Articles\\Replication Directory\\Paths", L"COFilesPath"));
	wcscpy(szPathLocal, (LPCTSTR)bstrPathLocal);


	if (wcslen(szPathServer) == 0 )				Log("szPathServer = 0. Please use the PutResource method of server service.");
	if (wcslen(szPathLocal) == 0 )				Log("szPathLocal = 0. Please fill the registry \\Paths\\CoFilesPath key.");
	//________________________________________________________________________________________________________
}


void CEventHandler::WriteSettingsPaths()
{
	//________________________________________________________________________________________________________
	//save settings in regs
	RegistryInf				mRegistryReadObj;

	if (wcslen(szPathServer) > 0 )
	mRegistryReadObj.PutKeyValue(L"SOFTWARE\\Articles\\Replication Directory\\AdminServer", L"COFilesPath", szPathServer);

	if (wcslen(szPathLocal) > 0 )
		mRegistryReadObj.PutKeyValue(L"SOFTWARE\\Articles\\Replication Directory\\Paths", L"COFilesPath", szPathLocal);

	//MessageBox(NULL, szPathServer, szPathLocal, MB_OK); 
	//________________________________________________________________________________________________________
}


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

 

CEventHandler::CEventHandler(CClient *pClient)
{
	//Beep(400, 200);
	//MessageBox(NULL, L"Mesaj din CEventHandler constructor", L"TEST", MB_OK);
	InitializeCriticalSection(&m_cs);
	//Lock();

	m_pClient			= pClient;
	m_bServerRunning	= true;
	szPathServer[0]		= '\0'; 
	szPathLocal[0]		= '\0';  
	
	DeleteLogs();
	

	m_evtStopThread = CreateEvent (NULL,				// No security attributes
									TRUE,				// Manual-reset event
									FALSE,				// Initial state is NONsignaled
									TEXT("EventStop"));	// Object name
	 
	ReadSettingsPaths();
	StartResync();
	StartCircle();
	
	//Unlock();
}

CEventHandler::~CEventHandler()
{	
}

HRESULT CEventHandler::FinalRelease()
{
	WriteSettingsPaths();
	StopCircle();
	
	return S_OK;
}

//*************************************************************************************************
//andi 
//26 mar 2002
//HELPER functions
//create a thread to made asyncronous calls
//*************************************************************************************************
static DWORD WINAPI WorkerThreadProc( LPVOID pParam )
{

	SCarry				*pcarry			= (SCarry*)pParam;
	CEventHandler		*pObject		= (CEventHandler*)pcarry->pClass;

	_bstr_t			bstrShareName(pcarry->bstrName);
	_bstr_t			bstrResource(pcarry->bstrValue);


	pObject->GetResource(bstrShareName, bstrResource);

	delete pcarry;
    return 0;   // thread completed successfully
}

static DWORD WINAPI WorkerThreadRunCircle( LPVOID pParam )
{

	SCarry				*pcarry			= (SCarry*)pParam;
	CEventHandler		*pObject		= (CEventHandler*)pcarry->pClass;


	pObject->RunCircle();

	delete pcarry;
    return 0;   // thread completed successfully
}

static DWORD WINAPI WorkerThreadRunResync( LPVOID pParam )
{

	SCarry				*pcarry			= (SCarry*)pParam;
	CEventHandler		*pObject		= (CEventHandler*)pcarry->pClass;


	pObject->RunResync();

	delete pcarry;
    return 0;   // thread completed successfully
}
//*************************************************************************************************
//andi 
//26 mar 2002
//HANDLER function
//create a thread to made asyncronous calls
//*************************************************************************************************
HRESULT __stdcall CEventHandler::OnNewResource(BSTR bstrInShareName, BSTR bstrInResource)
{
	//here are only the handler;
	//launch a thread here to make the job

	//MessageBox(NULL, bstrInShareName, bstrInResource, MB_OK);


	SCarry		*pcarry		= new SCarry;
	pcarry->bstrName		= bstrInShareName;
	pcarry->bstrValue		= bstrInResource;
	pcarry->pClass			= this;
	
	//create a new thread to made an asyncronous call
	HANDLE hThread = CreateThread(NULL, 0, WorkerThreadProc, pcarry, 0, NULL );
	
	return S_OK;
}


void	CEventHandler::GetResource(_bstr_t bstrShareName, _bstr_t bstrResource)
{
	//get a resource from server		//szPathServer
	//and copy on the local path		//szPathLocal	
	//Beep(600,100);
	
	USES_CONVERSION;

	char					szCmdExec[1024];
	char					szCmdExecMD[1024];
	CEnBSTR					enstr(L"");
	CEnBSTR					enstrCmdExec(L"");
	char					szServer[1024];
	char					szLocal[1024];


	enstr					= bstrResource;

	//build pathshare on server = \\servername\bstrShareName
	swprintf(szPathServer, L"\\\\%s\\%s", (LPTSTR)m_pClient->GetServerName(), (LPTSTR)bstrShareName);
	WriteSettingsPaths();

	if (wcslen(szPathLocal) == 0 )				
	{
		Log("szPathLocal = 0. Please fill the registry \\Paths\\CoFilesPath key.");
		return;
	}
	
	
	
	Lock();

	strcpy(szServer, T2A(szPathServer));
	strcpy(szLocal, T2A(szPathLocal));

	//look at the path's to have "\" termination 
	if	( szServer[(strlen(szServer)-1)] != '\\' ) 
	{
		szServer[(strlen(szServer))] = '\\';
		szServer[(strlen(szServer))+1] = '\0';
	}
	
	if	( szLocal[(strlen(szLocal)-1)] != '\\' ) 
	{
		szLocal[(strlen(szLocal))] = '\\';
		szLocal[(strlen(szLocal)+1)] = '\0';
	}


	//look at the beginning of string "\"
	if (0==(enstr.find("\\")))
	{
		bstrResource		= enstr		= enstr.mid(1);	
	}

	//if i find "."	 assuming its an file
	//create first directory
	if (enstr.find(".")>0)
	{
		char		*pdest;
		int			poz;


		strcpy(szCmdExecMD, enstr);

		pdest		= strrchr( szCmdExecMD, '\\' );
		poz			= pdest - szCmdExecMD;
		szCmdExecMD[poz]	= '\0';
		
		//make directory
		sprintf(szCmdExec, "cmd.exe /C md \"%s%s\"  >>c:\\temp\\LogReplicationClientDos.txt", szLocal, szCmdExecMD);
		Log(szCmdExec);
		enstrCmdExec	=  szCmdExec;
		//MessageBox(NULL, enstrCmdExec, L"CLIENT", MB_OK);
		
		RunShell(enstrCmdExec);

		//copy file
		sprintf(szCmdExec, "cmd.exe /C copy /Y \"%s%s\" \"%s%s\" >>c:\\temp\\LogReplicationClientDos.txt", szServer, (LPCSTR)bstrResource, szLocal, (LPCSTR)bstrResource);
		Log(szCmdExec);
		enstrCmdExec		= szCmdExec;
		
		RunShell(enstrCmdExec);
	}
	else
	{
		//its an directory
		 
		
		//strcpy(szCmdExec, "cmd.exe /k xcopy \\\\dev2\\kt\\atl\\example.xml c:\\temp\\ /E /R /K /Y /I >>c:\\temp\\fis.txt" );
		sprintf(szCmdExec, "cmd.exe /C xcopy \"%s%s\" \"%s%s\" /E /R /K /Y /I  >>c:\\temp\\LogReplicationClientDos.txt", szServer, (LPCSTR)bstrResource, szLocal, (LPCSTR)bstrResource);
		Log(szCmdExec);
		enstrCmdExec		= szCmdExec;
		//MessageBox(NULL, bstrCmdExec, L"CLIENT", MB_OK);
		
		RunShell(enstrCmdExec);
	}
 
	Unlock();
}

void	CEventHandler::WriteResource(_bstr_t bstrLongName, _bstr_t bstrValue)
{
	//write a resource local
}


void	CEventHandler::RunResync()
{
	
	USES_CONVERSION;
	//write a resource local
	char					szCmdExec[1024];
	CEnBSTR					enstrCmdExec(L"");
  
	char					szServer[1024]	= {0};
	char					szLocal[1024]	= {0};

	//xcopy \\dev2\kt\ATL C:\Temp\ATL\ /E /R /K /Y /D
	//see at the path's to don't have "\" termination 

	if (wcslen(szPathLocal) == 0 )				
	{
		Log("szPathLocal = 0. Please fill the registry \\Paths\\CoFilesPath key.");
		return;
	}


	Lock();
	strcpy(szServer, T2A(szPathServer));
	strcpy(szLocal, T2A(szPathLocal));
	 

	if	( szServer[(strlen(szServer)-1)] == '\\' ) 
		szServer[(strlen(szServer)-1)] = '\0';
	
	if	( szLocal[(strlen(szLocal)-1)] == '\\' ) 
		szLocal[(strlen(szLocal)-1)] = '\0';
	
	sprintf(szCmdExec, "cmd.exe /C xcopy \"%s\" \"%s\" /E /R /K /Y /I /D >>c:\\temp\\LogReplicationClientDos.txt", szServer, szLocal);
	Log(szCmdExec);
	enstrCmdExec		= szCmdExec;
	//MessageBox(NULL, bstrCmdExec, L"CLIENT", MB_OK);
	
	RunShell(enstrCmdExec);

	Unlock();
}

void	CEventHandler::StartResync()
{

	SCarry		*pcarry		= new SCarry;
	pcarry->bstrName		= L"";
	pcarry->bstrValue		= L""; 
	pcarry->pClass			= this;
	
	//create a new thread to made an asyncronous call
	HANDLE hThread = CreateThread(NULL, 0, WorkerThreadRunResync, pcarry, 0, NULL );
}

void	CEventHandler::DeleteLogs()
{
	Lock(); 
	
	FILE	*stream, *streamDos;

	try
	{
		stream = fopen( "c:\\\\temp\\LogReplicationClient.txt", "w+" );
		fclose( stream );

		streamDos = fopen( "c:\\\\temp\\LogReplicationClientDos.txt", "w+" );
		fclose( streamDos );
	}
	catch(...)
	{
	}

	Unlock();
}
void	CEventHandler::RunShell(_bstr_t bstrCmdExec)
{
	STARTUPINFO				si;
	PROCESS_INFORMATION		pi;  
	memset(&si,0,sizeof(STARTUPINFO));
	si.cb					= sizeof(STARTUPINFO);
	si.wShowWindow			= SW_SHOW;
	
	bool bbb	= CreateProcess(NULL, bstrCmdExec, NULL, NULL, false, 0, NULL, NULL, &si, &pi);
	if ( bbb = 0 )
	{
		//do some log
		//Beep(800, 600);
	}
	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);

	//bool bbb	= CreateProcess(NULL, L"cmd.exe /k xcopy \\\\dev2\\kt\\atl\\example.xml c:\\temp\\ /E /R /K /Y /I >>c:\\temp\\fis.txt", NULL, NULL, true, 0, NULL, NULL, &si, &pi);
	//WinExec("control.exe", SW_NORMAL);	
}

void	CEventHandler::RunCircle()
{
	#define NBHANDLES	1
	HANDLE handles[NBHANDLES]=	{	//(HANDLE) m_evtNotification,
									(HANDLE) m_evtStopThread 
								};

	DWORD dwWait;
	while ( m_bContinueToRun ) 
	{
		//Beep(800,800);
		if (m_pClient->ComPing() )
		{
			//Beep(200, 100);
			if (!m_bServerRunning)
			{
				Log("The server was down.");

				//radvise server to receive events
				m_pClient->Unadvise(); 
				if ( m_pClient->Readvise() )
				{
					m_bServerRunning	= true; 
					
					//Beep(1000,800);
					Log("Client readvice succefull.");
				}
				else
					Log("Client readvice UNSUCCESFULL.");

				//tell to others clients to readvise
				m_pClient->ReadviseAllLauncher();

				//rsync with server
				StartResync(); 
			}		
		}
		else
		{
			//Beep(900,100);
			Log("The server is down.");
			m_bServerRunning		= false;
		}

		// wait a notification to do
		dwWait = WaitForMultipleObjects(NBHANDLES, handles, FALSE, 6 * 1000);
		if( dwWait == WAIT_FAILED )
			continue;

		if( dwWait >= WAIT_OBJECT_0 && dwWait <= WAIT_OBJECT_0+NBHANDLES-1 )
		{
			if ( dwWait == WAIT_OBJECT_0 + 1)
				break;	// stop the thread..
			else
			{
				// notification..
			}
		}
		else
		{			// abandonned ..
		}

	}

} 


void	CEventHandler::StartCircle()
{
	m_bContinueToRun	=TRUE;
	//m_hThread			= ::CreateThread(NULL, 0, RunCircle, NULL, 0, &m_ThreadId );

	SCarry		*pcarry		= new SCarry;
	pcarry->bstrName		= L"";
	pcarry->bstrValue		= L""; 
	pcarry->pClass			= this;
	
	//create a new thread to made an asyncronous call
	m_hThread			 = CreateThread(NULL, 0, WorkerThreadRunCircle, pcarry, 0, &m_ThreadId );
}


void	CEventHandler::StopCircle()
{
	m_bContinueToRun	=FALSE;
	SetEvent(m_evtStopThread);

	WaitForSingleObject( m_hThread, 10000 );
	::TerminateThread(m_hThread, 98765321);
}



//############################################################
//
// Resync all
//
//############################################################
static DWORD WINAPI WorkerThreadSyncronize( LPVOID pParam )
{

	SCarry				*pcarry			= (SCarry*)pParam;
	CEventHandler		*pObject		= (CEventHandler*)pcarry->pClass;


	pObject->RunResync();

	delete pcarry;
    return 0;   // thread completed successfully
}

//*************************************************************************************************
//andi 
//26 mar 2002
//OnSyncronize method
//
//*************************************************************************************************
HRESULT __stdcall CEventHandler::OnSyncronize()
{
	SCarry		*pcarry		= new SCarry;
	pcarry->pClass			= this;

	//create a new thread to made an asyncronous call
	HANDLE hThread = CreateThread(NULL, 0, WorkerThreadSyncronize, pcarry, 0, NULL );
	
	return S_OK;
}



//#########################################################################
//
//Tell 2 server about as
//
//#########################################################################
static DWORD WINAPI WorkerThreadGetActiveClients( LPVOID pParam )
{

	SCarry				*pcarry			= (SCarry*)pParam;
	CEventHandler		*pObject		= (CEventHandler*)pcarry->pClass;


	pObject->Tell2Server();

	delete pcarry;
    return 0;   // thread completed successfully
}
//*************************************************************************************************
//andi 
//26 mar 2002
//OnGetActiveClients method
//
//*************************************************************************************************
HRESULT __stdcall CEventHandler::OnGetActiveClients()
{
	SCarry		*pcarry		= new SCarry;
	pcarry->pClass			= this;

	//create a new thread to made an asyncronous call
	HANDLE hThread = CreateThread(NULL, 0, WorkerThreadGetActiveClients, pcarry, 0, NULL );
	
	return S_OK;
}

void CEventHandler::Tell2Server()
{
	Log("Tell2Server:");
	m_pClient->Tell2Server(szPathLocal, szPathServer);
}