// EventHandler.h: interface for the CEventHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVENT2_H__D914DD91_B40C_40AB_96EE_5845FFE08F38__INCLUDED_)
#define AFX_EVENT2_H__D914DD91_B40C_40AB_96EE_5845FFE08F38__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class CClient;



class CEventHandler :
	public IDispEventImpl<
		0,
		CEventHandler,
		&DIID_IServerEvents,
		&LIBID_REPLICATIONSERVERLib,
		1,
		0>
{

public:
	CEventHandler(CClient *pClient);
	~CEventHandler();

	HRESULT				FinalRelease();

	HRESULT __stdcall	OnNewResource(BSTR bstrLongName, BSTR bstrValue);
	HRESULT __stdcall	OnSyncronize();
	HRESULT __stdcall	OnGetActiveClients();

	BEGIN_SINK_MAP(CEventHandler)
		SINK_ENTRY_EX(0, DIID_IServerEvents, 1, OnNewResource)
		SINK_ENTRY_EX(0, DIID_IServerEvents, 2, OnSyncronize)
		SINK_ENTRY_EX(0, DIID_IServerEvents, 3, OnGetActiveClients)
	END_SINK_MAP()

	
	void				GetResource(_bstr_t bstrShareName, _bstr_t bstrResource);
	void				WriteResource(_bstr_t bstrLongName, _bstr_t bstrResource);
	
	void				RunResync();
	void				RunCircle();

	void				Tell2Server();

private:
	void				Lock()		{	EnterCriticalSection(&m_cs);	};
	void				Unlock()	{	LeaveCriticalSection(&m_cs);	};
	void				RunShell(_bstr_t bstrCmdExec);
	
	void				StartResync();
	void				StartCircle();
	void				StopCircle();


	void				DeleteLogs();

	void				ReadSettingsPaths();
	void				WriteSettingsPaths();

	TCHAR				szPathServer[512];
	TCHAR				szPathLocal[512];


		CRITICAL_SECTION	m_cs;
		CClient				*m_pClient;
	
		HANDLE  			m_evtStopThread;
		HANDLE				m_hThread;
		HANDLE				m_hThreadSignalServer;
		DWORD				m_ThreadId;
		bool				m_bContinueToRun;
		bool				m_bServerRunning;
};




#endif // !defined(AFX_EVENT2_H__D914DD91_B40C_40AB_96EE_5845FFE08F38__INCLUDED_)
