#ifndef __SIGNALS_H__
#define __SIGNALS_H__




#define		MAX_MSGLEN		80
#define		MAX_ADDLEN		80
#define		MAX_MSLOTNAME	80


bool GetComputerName( LPTSTR &szName, LPTSTR &szError )
{
//Get the machine name
	WORD			wVersionRequested;
	WSADATA			wsaData;
	int				err;
	CHAR			szLocalName[MAX_MSGLEN];
	ULONG			dwLen							= MAX_MSGLEN;
	
	wVersionRequested = MAKEWORD( 2, 2 );
	
	err = WSAStartup( wVersionRequested, &wsaData );
	if ( err != 0 ) {
		/* Tell the user that we could not find a usable */
		/* WinSock DLL.                                  */
		wcscpy(szError, L"Can't find a usable WinSock DLL");
		return false;
	}

	if(gethostname(szLocalName, dwLen) != NO_ERROR)
    {
		wcscpy(szError, L"Can't gethostname");
		return false;
    }
	
	USES_CONVERSION;

	wcscpy( szName, A2T( szLocalName ) );
	

	WSACleanup();
 
	
	return true;
}


bool DoMailSlot (     LPTSTR lpsName, HANDLE &hSlot, LPTSTR &szError  )
{	

	TCHAR				achMailSlotName[MAX_MSLOTNAME];

 
	// Create a string for the mailslot name.
    wsprintf ( achMailSlotName, L"\\\\.\\mailslot\\%s", lpsName );

	//MessageBox(NULL, achMailSlotName, L"CREATE", MB_OK);
    
    // Create the mailslot.
    hSlot = CreateMailslot (	achMailSlotName,
								0, 
								//MAILSLOT_WAIT_FOREVER,//10 * 1000,	//0,//MAILSLOT_WAIT_FOREVER,
								10 * 1000,
								(LPSECURITY_ATTRIBUTES) NULL
							);
 
    if ( INVALID_HANDLE_VALUE == hSlot )
    {
		LPVOID lpMsgBuf;
		FormatMessage( 
						FORMAT_MESSAGE_ALLOCATE_BUFFER | 
						FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						(LPTSTR) &lpMsgBuf,
						0,
						NULL 
						);
		// Display the string.
		wsprintf(szError, L"Error in CreateMailSlot:  %s", (LPCTSTR)lpMsgBuf);
		// Free the buffer.
		LocalFree( lpMsgBuf );
		return false;
    }

	return true; 
}

bool DoMailSlotServerMessageWrite (  LPTSTR lpsName, LPTSTR lpsMessage, LPTSTR &szError  )
{
	HANDLE		hFile;
	
	// Variables that store MessageID, number of bytes to write/written.
	DWORD		//dwMessageID, 
				cbWritten,
				cbToWrite;
	
	BOOL		fResult;

	TCHAR		achMailSlotName[MAX_MSLOTNAME],
				achBuffer[MAX_MSGLEN + sizeof ( DWORD ) ];

	// Create a string for the mailslot name.
    wsprintf (	achMailSlotName, L"\\\\*\\mailslot\\%s", lpsName );   //all in global domain

	//MessageBox(NULL, achMailSlotName, L"WRITE", MB_OK);

	// Open a handle to the mailslot.
    hFile = CreateFile (	 achMailSlotName,
							 GENERIC_WRITE,
							 FILE_SHARE_READ,
							 (LPSECURITY_ATTRIBUTES) NULL,
							 OPEN_EXISTING,
							 FILE_ATTRIBUTE_NORMAL,
							 (HANDLE) NULL 
							 );
    
    if ( INVALID_HANDLE_VALUE == hFile)
    {
		LPVOID lpMsgBuf;
		FormatMessage( 
						FORMAT_MESSAGE_ALLOCATE_BUFFER | 
						FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						(LPTSTR) &lpMsgBuf,
						0,
						NULL 
						);
		// Display the string.
		wsprintf(szError, L"Error in mailslot CreateFile:  %s", (LPCTSTR)lpMsgBuf);
		// Free the buffer.
		LocalFree( lpMsgBuf );
		return false;
    }

	// Generate a Message ID.
    /*srand ( (UINT) time ( NULL) );
    dwMessageID		= rand ( );

	wsprintf(achBuffer, L"%d-%s", dwMessageID, lpsMessage);
	*/
	wcscpy(achBuffer, lpsMessage); 

    // Total number of bytes to write.
    //cbToWrite = sizeof ( DWORD ) + wcslen ( achBuffer + sizeof ( DWORD ) );
	cbToWrite	= wcslen ( achBuffer ) *2;  
	
    // Send a mailslot message.
    fResult = WriteFile (	  hFile,
							  achBuffer,
							  cbToWrite,
							  &cbWritten,
							  (LPOVERLAPPED) NULL
						);
 
    if ( TRUE != fResult )
    {
		LPVOID lpMsgBuf; 
		FormatMessage( 
						FORMAT_MESSAGE_ALLOCATE_BUFFER | 
						FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						(LPTSTR) &lpMsgBuf,
						0,
						NULL 
						);
		// Display the string.
		wsprintf(szError, L"Error in mailslot WriteFile:  %s", (LPCTSTR)lpMsgBuf);
		// Free the buffer.
		LocalFree( lpMsgBuf );
		return false;
    }

	
	//MessageBox(NULL, achBuffer, L"WRITE", MB_OK);

	return true;  
}

bool DoMailSlotMessageRead (  LPTSTR lpsName, HANDLE hSlot, LPTSTR &lpsMessage, LPTSTR &szError  )
{
	
	 
	// Variables that store MessageID, previous messageID, number of bytes to 
	// read/read, size of next available message and the number of messages.
	DWORD	//	dwMessageID,
			//	dwPrevID,
			//	cbMessage,
				cbRead, 
				cbToRead, 
				nMessages;
	
	BOOL		fResult;
	
	TCHAR		achBuffer[MAX_MSGLEN + sizeof ( DWORD )];
	
	
    cbToRead = MAX_MSGLEN + sizeof (DWORD);

	//MessageBox(NULL, L"Read", L"READ", MB_OK);
	
	// Post ReadFile() and read a message.
    fResult = ReadFile (	hSlot,
							achBuffer,
							cbToRead,
							&cbRead,
							(LPOVERLAPPED) NULL
						);
    
    if ( TRUE != fResult )
    {
		LPVOID lpMsgBuf;
		FormatMessage( 
						FORMAT_MESSAGE_ALLOCATE_BUFFER | 
						FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						(LPTSTR) &lpMsgBuf,
						0,
						NULL 
						);
		// Display the string.
		wsprintf(szError, L"Error in mailslot ReadFile:  %s", (LPCTSTR)lpMsgBuf);
		// Free the buffer.
		LocalFree( lpMsgBuf );
		return false;
    }
	 
	cbRead				= cbRead/2; 
    achBuffer[cbRead]	= '\0';
	

	//MessageBox(NULL, achBuffer, L"READ", MB_OK);
	
/*	
    // Get the message ID part from the message.
    //memcpy ( &dwMessageID, achBuffer, sizeof ( DWORD ) );
	TCHAR		*pdest;
	TCHAR		szNo[10];
	int			poz;

	pdest		= wcschr( achBuffer, '-' );  
	poz			= pdest - achBuffer ;

	wcsncpy(szNo  , achBuffer, poz);
	szNo[poz]		= '\0';
	dwMessageID		= _wtol(szNo);
	
	
    // Adjust the actual message pointer.
    //lpsMessage		= achBuffer + sizeof ( DWORD );
	wcscpy(lpsMessage  , pdest+1);
	
    // Check for duplicate messages.
    dwPrevID		= dwMessageID;
    
*/
	wcscpy(lpsMessage, achBuffer);

	/*
    while ( 1 )
    {
		// get information on pending messages.
		fResult			= GetMailslotInfo (		hSlot,
												(LPDWORD) NULL,
												&cbMessage, 
												&nMessages,
												(LPDWORD) NULL
											);
		if ( TRUE != fResult )
		{ 
			LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
				);
			// Display the string.
			wsprintf(szError, L"Error in mailslot GetMailslotInfo:  %s", (LPCTSTR)lpMsgBuf);
			// Free the buffer.
			LocalFree( lpMsgBuf );
			return false;
		}
		
		// Break if no more messages.
		if ( MAILSLOT_NO_MESSAGE == cbMessage )
			break;
		
		// We now know how much to read.
		cbToRead		= cbMessage;
		fResult			= ReadFile (	hSlot,
										achBuffer,
										cbToRead,
										&cbRead,
										(LPOVERLAPPED) NULL
									);
		
		if ( TRUE != fResult )
		{
			LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
				);
			// Display the string.
			wsprintf(szError, L"Error in mailslot ReadFile:  %s", (LPCTSTR)lpMsgBuf);
			// Free the buffer.
			LocalFree( lpMsgBuf );
			return false;
		}
		
		
		cbRead				= cbRead/2; 
		achBuffer[cbRead]	= '\0';

		memcpy ( &dwMessageID, achBuffer, sizeof (DWORD) );
		
		// print the message only if it is not a duplicate.
		lpsMessage			= achBuffer + sizeof (DWORD);
		if ( dwMessageID != dwPrevID )    
		{
			//fprintf ( stdout,   "A MailSlot Message of %d bytes received with ID %d\n", strlen (lpsMessage ), dwMessageID );
			//fprintf ( stdout, "MessageText->%s\n", achBuffer );
			//MessageBox(NULL, achBuffer, L"READ", MB_OK);
		}
		
		dwPrevID			= dwMessageID;
    }
    */
    
   
	return true;
}

bool DoMailSlotClose(HANDLE hSlot, LPTSTR &szError)
{
	BOOL		fResult;

	 // Close the handle to our mailslot.
    fResult			= CloseHandle ( hSlot );
    if ( TRUE != fResult )
    {
		LPVOID lpMsgBuf;
		FormatMessage( 
						FORMAT_MESSAGE_ALLOCATE_BUFFER | 
						FORMAT_MESSAGE_FROM_SYSTEM | 
						FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						(LPTSTR) &lpMsgBuf,
						0,
						NULL 
						);
		// Display the string.
		wsprintf(szError, L"Error in mailslot CloseHandle:  %s", (LPCTSTR)lpMsgBuf);
		// Free the buffer.
		LocalFree( lpMsgBuf );
		return false;
    }
	return true;
}




//*********************************************************************************************
//SignalClients 
//management of mailslot server
//
//*********************************************************************************************
bool	PutSignal(LPTSTR szMailslotName, LPTSTR &szError)
{
	LPTSTR			szMessage	= {0};
	szMessage					= (TCHAR*) malloc( MAX_MSGLEN * sizeof(TCHAR) );
	
	if ( !GetComputerName(szMessage, szError) )								return false;

	if ( !DoMailSlotServerMessageWrite(szMailslotName, szMessage, szError))	return false;	
	

	//MessageBox(NULL, L"DoMailSlotServer OK", L"",  MB_OK);
	free( szMessage );

	return true;
}

//*********************************************************************************************
//SignalClients 
//management of mailslot server
//
//*********************************************************************************************
bool	PutSignalReadvise(LPTSTR szMailslotName, LPTSTR &szError)
{
	LPTSTR			szMessage	= {0};
	szMessage					= (TCHAR*) malloc( MAX_MSGLEN * sizeof(TCHAR) );
	
	wcscpy(szMessage, L"readvise");

	if ( !DoMailSlotServerMessageWrite(szMailslotName, szMessage, szError))	return false;	
	

	//MessageBox(NULL, L"DoMailSlotServer OK", L"",  MB_OK);
	free( szMessage );

	return true;
}

//*********************************************************************************************
//GetSignals 
//management of mailslot server
//
//*********************************************************************************************
bool	GetSignals(LPTSTR szMailslotName, LPTSTR &szMessage, LPTSTR &szError)
{
	HANDLE		hSlot; 
	if ( !DoMailSlot(szMailslotName, hSlot, szError))						goto err;

	if ( !DoMailSlotMessageRead(szMailslotName, hSlot, szMessage, szError))	goto err;	

	if ( !DoMailSlotClose(hSlot, szError))									goto err;	

	//MessageBox(NULL, L"GetSignals OK", L"",  MB_OK);
	
	return true;

err:
	if ( !DoMailSlotClose(hSlot, szError))									return false;	
	return false;
}


#endif (__SIGNALS_H__)