// ReplicationServer.cpp : Implementation of WinMain


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f ReplicationServerps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "ReplicationServer.h"

#include "ReplicationServer_i.c" 

#include "Server.h" 

 
//___________________________________________________________________
LPTSTR		szAccountDefault(L"IXNET");
LPTSTR		szPathKey(_T("SOFTWARE\\Articles\\Replication Directory\\AdminServer"));
LPTSTR		szMailslotName(L"IXNET");


#include "..\ReplicationClient\ServiceRights.h"
#include "..\ReplicationClient\AccountMannager.h"
#include "..\ReplicationClient\ShareMannager.h"
#include "..\ReplicationClient\Signals.h"
//___________________________________________________________________


CServiceModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_Server, CServer)
END_OBJECT_MAP()


LPCTSTR FindOneOf(LPCTSTR p1, LPCTSTR p2)
{
    while (p1 != NULL && *p1 != NULL)
    {
        LPCTSTR p = p2;
        while (p != NULL && *p != NULL)
        {
            if (*p1 == *p)
                return CharNext(p1);
            p = CharNext(p);
        }
        p1 = CharNext(p1);
    }
    return NULL;
}



//****************************************************************************************
//Signal clients thread module
//Management of account
void   Log(LPTSTR sz)
{
	FILE *stream;
	USES_CONVERSION;

	char		szData[1024];
	strcpy(szData, T2A(sz));

	try
	{
		stream = fopen( "c:\\\\temp\\LogReplicationServer.txt", "a+" );
		fwrite( szData, 1, strlen(szData), stream );
		fwrite( "\r\n", 1, strlen("\r\n"), stream );
		 
		fclose( stream );
	}
	catch(...)
	{
	}
}

void CServiceModule::ReadSettingsRegsAccount(LPTSTR &szAccountName, LPTSTR &szAccountPassword)
{
	//read settings from regs
	RegistryInf			mRegistryReadObj;
	
	_bstr_t				bstrAccountName( mRegistryReadObj.GetKeyValue( szPathKey,_T("SVCUserName")) );
	wcscpy(szAccountName, (LPCTSTR)bstrAccountName);

	_bstr_t				bstrAccountPassword( mRegistryReadObj.GetKeyValue( szPathKey,_T("SVCUserPass")));
	wcscpy(szAccountPassword, (LPCTSTR)bstrAccountPassword);
}

void CServiceModule::ReadSettingsRegsShare(LPTSTR &szPathRoot, LPTSTR &szDirectory)
{
	//read settings from regs 
	RegistryInf			mRegistryReadObj;
	
	_bstr_t				bstrPathRoot( mRegistryReadObj.GetKeyValue( szPathKey,_T("PathRoot")) );
	wcscpy(szPathRoot, (LPCTSTR)bstrPathRoot);

	_bstr_t				bstrDirectory( mRegistryReadObj.GetKeyValue( szPathKey,_T("ShareDirectory")));
	wcscpy(szDirectory, (LPCTSTR)bstrDirectory);
}

void CServiceModule::WriteSettingsRegsAccount(LPTSTR szAccountName, LPTSTR AccountPassword)
{
	RegistryInf			mRegistryReadObj; 
 

	mRegistryReadObj.PutKeyValue(szPathKey, L"SVCUserName", _wcsupr(_wcsdup(szAccountName)));
	mRegistryReadObj.PutKeyValue(szPathKey, L"SVCUserPass", AccountPassword);
}

void CServiceModule::WriteSettingsRegsShare(_bstr_t bstrPathRoot, _bstr_t bstrDirectory)
{	
	RegistryInf				mRegistryReadObj;
	
	if (bstrPathRoot.length() > 0 )
		mRegistryReadObj.PutKeyValue(L"SOFTWARE\\Connex Intranet\\AdminServer", L"PathRoot", bstrPathRoot);
	
	if (bstrDirectory.length() > 0 )
		mRegistryReadObj.PutKeyValue(L"SOFTWARE\\Connex Intranet\\AdminServer", L"ShareDirectory", bstrDirectory);	
}
 
CServiceModule::CServiceModule()
{
	m_szAccountName[0]		= '\0';
	m_szAccountPassword[0]	= '\0';
	_bstr_t					bstrError(L"");

	DeleteLogs();  

	m_evtStopThread		= CreateEvent (NULL,			// No security attributes
									TRUE,				// Manual-reset event
									FALSE,				// Initial state is NONsignaled
									TEXT("EventStop"));	// Object name
	
	//________________________________________________________________________________
	//management of user account credentials
	if (!ManageAccount())
	{
		//return false;
	}
	//________________________________________________________________________________



	if ( !DeleteShare() )
	{
		//RETURN_ERROR((LPTSTR)bstrError);
	}


	StartSignalClients();
}

CServiceModule::~CServiceModule() 
{ 
	
	WriteSettingsRegsShare(m_bstrPathRoot, m_bstrDirectory);

	StopSignalClients();
}

void	CServiceModule::DeleteLogs()
{
	FILE	*stream;
 
	try
	{
		stream = fopen( "c:\\\\temp\\LogReplicationServer.txt", "w+" );
		fclose( stream );
	}
	catch(...)
	{
	}
}
	

bool	CServiceModule::ManageAccount() 
{
	//Manage Account 
	
	LPTSTR				szError(L"");
	LPTSTR				szAccountName(L"");
	LPTSTR				szAccountPassword(L"");

	szError				= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );
	szAccountName		= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );
	szAccountPassword	= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );
	
	//read settings from regs
	ReadSettingsRegsAccount(szAccountName, szAccountPassword);    

 
	if ( !LookupUser( szAccountName, szAccountPassword,  szError) == RTN_OK) 
	{		
        MessageBox(NULL, szError, _T("Couldn't manage the account."), MB_OK);
		Log(szError);
		return FALSE; 
	}  


	//Give service security rights	
	if ( !GiveServiceRights( szAccountName,  szError) == RTN_OK)
	{
		MessageBox(NULL, szError, _T("Couldn't give service rights to the account."), MB_OK);
		Log(szError); 
		return false;
	}
 
	//MessageBox(NULL, szAccountName, szAccountPassword, MB_OK);
	WriteSettingsRegsAccount(szAccountName, szAccountPassword);			//save account in regs


	wcscpy(m_szAccountName,		szAccountName);
	wcscpy(m_szAccountPassword, szAccountPassword);

	free( szError );
	free( szAccountName );
	free( szAccountPassword ); 
 
	return true; 
}

bool	CServiceModule::DeleteShare()
{
	//MessageBox(NULL, bstrPathRoot, bstrDirectory,  MB_OK);
	_bstr_t			bstrError(L"");
	LPTSTR			pszError(L"");
	LPTSTR			pszPathRoot(L"");
	LPTSTR			pszDirectory(L"");

	pszError		= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );
	pszPathRoot		= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );
	pszDirectory	= (TCHAR*) malloc( 1024 * sizeof(TCHAR) ); 

  	//read settings from regs
	ReadSettingsRegsShare(pszPathRoot, pszDirectory);    

	//look if is the first time (var's are not saved in regs)
	if ( (wcslen(pszPathRoot)>3) && (wcslen(pszDirectory)>3))
	{
		if ( !::DeleteShare(pszPathRoot, pszDirectory, pszError) )
		{
			bstrError	= L"Couldn't delete share.";
			bstrError	+= L"<";
			bstrError	+=  pszPathRoot;
			bstrError	+=  pszDirectory;
			bstrError	+= L">.";
			
			MessageBox(NULL, pszError, bstrError, MB_OK);
			Log(pszError);
			bstrError			= pszError;
			free( pszError );
			
			return false;
		}
		
		
		if ( ! ManageShare(pszPathRoot, pszDirectory, &bstrError) )
		{
			bstrError	= L"Couldn't make share.";
			bstrError	+= L"<";
			bstrError	+=  pszPathRoot;
			bstrError	+=  pszDirectory;
			bstrError	+= L">.";
			
			MessageBox(NULL, pszError, bstrError, MB_OK);
			Log(pszError);
			bstrError			= pszError;
			free( pszError );
			
			return false;
		}
		
	}


	free( pszError );
	return true;
}

bool	CServiceModule::ManageShare(_bstr_t  bstrPathRoot, _bstr_t bstrDirectory, _bstr_t *bstrError)
{
	static bool	bRegsWrited(false);


	//MessageBox(NULL, bstrPathRoot, bstrDirectory,  MB_OK);
	LPTSTR		szError(L"");
	szError		= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );

	LPTSTR		szPathRoot(bstrPathRoot);
	LPTSTR		szDirectory(bstrDirectory);

  
	if ( !LookupShare(bstrPathRoot, bstrDirectory, m_szAccountName, szError) )
	{
		//MessageBox(NULL, szError, _T("Couldn't share."), MB_OK);
		Log(szError);
		*bstrError			= szError;
		free( szError );

		return false;
	}


	if (!bRegsWrited)										//save share path and name to later use
	{	
		WriteSettingsRegsShare(bstrPathRoot, bstrDirectory);
		bRegsWrited				= true;
	}
	
	m_bstrPathRoot			= bstrPathRoot;
	m_bstrDirectory			= bstrDirectory;

	
	free( szError );
	return true;
}


static DWORD WINAPI WorkerThreadSignalClients( LPVOID pParam )
{
	
	SCarry			*pcarry			= (SCarry*)pParam;
	CServiceModule	*pObject		= (CServiceModule*)pcarry->pClass;


	pObject->SignalClients();

	delete pcarry;
    return 0;   // thread completed successfully
}

void	CServiceModule::SignalClients()
{
	#define NBHANDLES	1
	HANDLE handles[NBHANDLES]=	{	//(HANDLE) m_evtNotification,
									(HANDLE) m_evtStopThread 
								};

	//MessageBox(NULL, L"LookupSignals", L"", MB_OK);

	DWORD dwWait;
	while ( m_bContinueToRun )
	{
		// write sometime the mesaj info to clients mailslots

		//Beep(200, 200); 
		{
			LPTSTR		szError(L"");
			szError		= (TCHAR*) malloc( 1024 * sizeof(TCHAR) );
			if ( !PutSignal(szMailslotName, szError) )
			{
				//log here
				Log(szError);
				//MessageBox(NULL, szError, _T("Couldn't SignalClients."), MB_OK);
			}
			free( szError ); 
		}


		//wait for exit thread event
		dwWait		= WaitForMultipleObjects(NBHANDLES, handles, FALSE, 6 * 1000);
		

		if( dwWait == WAIT_FAILED )
			continue;

		if( dwWait >= WAIT_OBJECT_0 && dwWait <= WAIT_OBJECT_0+NBHANDLES-1 )
		{
			if ( dwWait == WAIT_OBJECT_0 + 1)
				break;	// stop the thread..
			else
			{
				// notification..
			}
		}
		else
		{			// abandonned ..
		}

		
	}
}

void	CServiceModule::StartSignalClients()
{
	m_bContinueToRun	=TRUE; 
	ResetEvent(m_evtStopThread);
 

	SCarry		*pcarry		= new SCarry;
	pcarry->bstrPathRoot		= L"";
	pcarry->bstrDirectory		= L"";
	pcarry->bstrResourceName	= L"";
	pcarry->pClass			= this;
	
	//create a new thread to made an asyncronous call
	m_hThread			 = CreateThread(NULL, 0, WorkerThreadSignalClients, pcarry, 0, &m_ThreadId );
}

void	CServiceModule::StopSignalClients()
{
	m_bContinueToRun	=FALSE;
	SetEvent(m_evtStopThread);

	WaitForSingleObject( m_hThread, 10000 );
	::TerminateThread(m_hThread, 98765321);
}




//****************************************************************************************





// Although some of these functions are big they are declared inline since they are only used once
inline HRESULT CServiceModule::RegisterServer(BOOL bRegTypeLib, BOOL bService)
{
    HRESULT hr = CoInitialize(NULL);
    if (FAILED(hr))
        return hr;

    // Remove any previous service since it may point to
    // the incorrect file
    Uninstall();

    // Add service entries
    UpdateRegistryFromResource(IDR_ReplicationServer, TRUE);

    // Adjust the AppID for Local Server or Service
    CRegKey keyAppID;
    LONG lRes = keyAppID.Open(HKEY_CLASSES_ROOT, _T("AppID"), KEY_WRITE);
    if (lRes != ERROR_SUCCESS)
        return lRes;

    CRegKey key;
    lRes = key.Open(keyAppID, _T("{4F98D282-5DE2-4932-BB68-716458EB40C6}"), KEY_WRITE);
    if (lRes != ERROR_SUCCESS)
        return lRes;
    key.DeleteValue(_T("LocalService"));
    
    if (bService)
    {
        key.SetValue(_T("ReplicationServer"), _T("LocalService"));
        key.SetValue(_T("-Service"), _T("ServiceParameters"));
        // Create service
        Install();
    }

    // Add object entries
    hr = CComModule::RegisterServer(bRegTypeLib);

    CoUninitialize();
    return hr;
}

inline HRESULT CServiceModule::UnregisterServer()
{
    HRESULT hr = CoInitialize(NULL);
    if (FAILED(hr))
        return hr;

    // Remove service entries
    UpdateRegistryFromResource(IDR_ReplicationServer, FALSE);
    // Remove service
    Uninstall();
    // Remove object entries
    CComModule::UnregisterServer(TRUE);
    CoUninitialize();
    return S_OK;
}

inline void CServiceModule::Init(_ATL_OBJMAP_ENTRY* p, HINSTANCE h, UINT nServiceNameID, const GUID* plibid)
{
    CComModule::Init(p, h, plibid);

    m_bService = TRUE;

    LoadString(h, nServiceNameID, m_szServiceName, sizeof(m_szServiceName) / sizeof(TCHAR));

    // set up the initial service status 
    m_hServiceStatus = NULL;
    m_status.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
    m_status.dwCurrentState = SERVICE_STOPPED;
    m_status.dwControlsAccepted = SERVICE_ACCEPT_STOP;
    m_status.dwWin32ExitCode = 0;
    m_status.dwServiceSpecificExitCode = 0;
    m_status.dwCheckPoint = 0;
    m_status.dwWaitHint = 0;
}

LONG CServiceModule::Unlock()
{
    LONG l = CComModule::Unlock();
    if (l == 0 && !m_bService)
        PostThreadMessage(dwThreadID, WM_QUIT, 0, 0);
    return l;
}

BOOL CServiceModule::IsInstalled()
{
    BOOL bResult = FALSE;

    SC_HANDLE hSCM = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

    if (hSCM != NULL)
    {
        SC_HANDLE hService = ::OpenService(hSCM, m_szServiceName, SERVICE_QUERY_CONFIG);
        if (hService != NULL)
        {
            bResult = TRUE;
            ::CloseServiceHandle(hService);
        }
        ::CloseServiceHandle(hSCM);
    }
    return bResult;
}

inline BOOL CServiceModule::Install()
{
    if (IsInstalled())
        return TRUE;

    SC_HANDLE hSCM = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
    if (hSCM == NULL)
    {
        MessageBox(NULL, _T("Couldn't open service manager"), m_szServiceName, MB_OK); 
        return FALSE;
    }

    // Get the executable file path
    TCHAR szFilePath[_MAX_PATH];
    ::GetModuleFileName(NULL, szFilePath, _MAX_PATH);



	
 /*
    SC_HANDLE hService = ::CreateService( 
        hSCM, m_szServiceName, m_szServiceName,
        SERVICE_ALL_ACCESS, SERVICE_WIN32_OWN_PROCESS | SERVICE_INTERACTIVE_PROCESS,
        SERVICE_AUTO_START, SERVICE_ERROR_NORMAL, 
        szFilePath, NULL, NULL, _T("RPCSS\0"), NULL, NULL);
*/
	
	SC_HANDLE hService = ::CreateService( 
        hSCM, m_szServiceName, m_szServiceName, 
        SERVICE_ALL_ACCESS, SERVICE_WIN32_OWN_PROCESS, 
        SERVICE_AUTO_START, SERVICE_ERROR_NORMAL, 
        szFilePath, NULL, NULL, _T("RPCSS\0"), m_szAccountName, m_szAccountPassword);
	 

    if (hService == NULL)
    { 
        ::CloseServiceHandle(hSCM);
        MessageBox(NULL, _T("Couldn't create service"), m_szServiceName, MB_OK);
        return FALSE;
    }

    ::CloseServiceHandle(hService);
    ::CloseServiceHandle(hSCM);


    return TRUE;
}

inline BOOL CServiceModule::Uninstall()
{
    if (!IsInstalled())
        return TRUE;

    SC_HANDLE hSCM = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

    if (hSCM == NULL)
    {
        MessageBox(NULL, _T("Couldn't open service manager"), m_szServiceName, MB_OK);
        return FALSE;
    }

    SC_HANDLE hService = ::OpenService(hSCM, m_szServiceName, SERVICE_STOP | DELETE);

    if (hService == NULL)
    {
        ::CloseServiceHandle(hSCM);
        MessageBox(NULL, _T("Couldn't open service"), m_szServiceName, MB_OK);
        return FALSE;
    }
    SERVICE_STATUS status;
    ::ControlService(hService, SERVICE_CONTROL_STOP, &status);

    BOOL bDelete = ::DeleteService(hService);
    ::CloseServiceHandle(hService);
    ::CloseServiceHandle(hSCM);

    if (bDelete)
        return TRUE;

    MessageBox(NULL, _T("Service could not be deleted"), m_szServiceName, MB_OK);
    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////
// Logging functions
void CServiceModule::LogEvent(LPCTSTR pFormat, ...)
{
    TCHAR    chMsg[256];
    HANDLE  hEventSource;
    LPTSTR  lpszStrings[1];
    va_list pArg;

    va_start(pArg, pFormat);
    _vstprintf(chMsg, pFormat, pArg);
    va_end(pArg);

    lpszStrings[0] = chMsg;

    if (m_bService)
    {
        /* Get a handle to use with ReportEvent(). */
        hEventSource = RegisterEventSource(NULL, m_szServiceName);
        if (hEventSource != NULL)
        {
            /* Write to event log. */
            ReportEvent(hEventSource, EVENTLOG_INFORMATION_TYPE, 0, 0, NULL, 1, 0, (LPCTSTR*) &lpszStrings[0], NULL);
            DeregisterEventSource(hEventSource);
        }
    }
    else
    {
        // As we are not running as a service, just write the error to the console.
        _putts(chMsg);
    }
}

//////////////////////////////////////////////////////////////////////////////////////////////
// Service startup and registration
inline void CServiceModule::Start()
{
    SERVICE_TABLE_ENTRY st[] =
    {
        { m_szServiceName, _ServiceMain },
        { NULL, NULL }
    };
    if (m_bService && !::StartServiceCtrlDispatcher(st))
    {
        m_bService = FALSE;
    }
    if (m_bService == FALSE)
        Run();
}

inline void CServiceModule::ServiceMain(DWORD /* dwArgc */, LPTSTR* /* lpszArgv */)
{
    // Register the control request handler
    m_status.dwCurrentState = SERVICE_START_PENDING;
    m_hServiceStatus = RegisterServiceCtrlHandler(m_szServiceName, _Handler);
    if (m_hServiceStatus == NULL)
    {
        LogEvent(_T("Handler not installed"));
        return;
    }
    SetServiceStatus(SERVICE_START_PENDING);
	

    m_status.dwWin32ExitCode = S_OK;
    m_status.dwCheckPoint = 0;
    m_status.dwWaitHint = 0;

    // When the Run function returns, the service has stopped.
    Run();

    SetServiceStatus(SERVICE_STOPPED);
    LogEvent(_T("Service stopped"));
}

inline void CServiceModule::Handler(DWORD dwOpcode)
{	
    switch (dwOpcode)
    {
    case SERVICE_CONTROL_STOP:
		//lTalk		= 0;
        SetServiceStatus(SERVICE_STOP_PENDING);
        PostThreadMessage(dwThreadID, WM_QUIT, 0, 0);
        break;
    case SERVICE_CONTROL_PAUSE:
		//lTalk		= 0;
        break;
    case SERVICE_CONTROL_CONTINUE:
		//lTalk		= 1;
        break;
    case SERVICE_CONTROL_INTERROGATE:
		//lTalk		= 0;
        break;
    case SERVICE_CONTROL_SHUTDOWN:
		//lTalk		= 0;
        break;
    default:
        LogEvent(_T("Bad service request"));
    }
}

void WINAPI CServiceModule::_ServiceMain(DWORD dwArgc, LPTSTR* lpszArgv)
{
    _Module.ServiceMain(dwArgc, lpszArgv);
}
void WINAPI CServiceModule::_Handler(DWORD dwOpcode)
{
    _Module.Handler(dwOpcode); 
}

void CServiceModule::SetServiceStatus(DWORD dwState)
{
    m_status.dwCurrentState = dwState;
    ::SetServiceStatus(m_hServiceStatus, &m_status);
}






void CServiceModule::Run()
{
    _Module.dwThreadID = GetCurrentThreadId();

//    HRESULT hr = CoInitialize(NULL);
//  If you are running on NT 4.0 or higher you can use the following call
//  instead to make the EXE free threaded.
//  This means that calls come in on a random RPC thread
  HRESULT hr = CoInitializeEx(NULL, COINIT_MULTITHREADED);

    _ASSERTE(SUCCEEDED(hr));

    // This provides a NULL DACL which will allow access to everyone.
    CSecurityDescriptor sd;
    sd.InitializeFromThreadToken();

/*    hr = CoInitializeSecurity(sd, -1, NULL, NULL,
        RPC_C_AUTHN_LEVEL_PKT, RPC_C_IMP_LEVEL_IMPERSONATE, NULL, EOAC_NONE, NULL);
    _ASSERTE(SUCCEEDED(hr));
*/
	  hr = CoInitializeSecurity(NULL, -1, NULL, NULL,
		RPC_C_AUTHN_LEVEL_NONE, RPC_C_IMP_LEVEL_IDENTIFY /*,RPC_C_IMP_LEVEL_DELEGATE*/ , NULL, EOAC_NONE, NULL);
	ATLASSERT(SUCCEEDED(hr));

    hr = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER | CLSCTX_REMOTE_SERVER, REGCLS_MULTIPLEUSE);
    _ASSERTE(SUCCEEDED(hr));




    LogEvent(_T("Service started")); 
    if (m_bService) 
	{
        SetServiceStatus(SERVICE_RUNNING);
		//lTalk		= 0;
	}

    MSG msg;
    while (GetMessage(&msg, 0, 0, 0))
        DispatchMessage(&msg);

    _Module.RevokeClassObjects();

    CoUninitialize();
}

/////////////////////////////////////////////////////////////////////////////
//
extern "C" int WINAPI _tWinMain(HINSTANCE hInstance, 
    HINSTANCE /*hPrevInstance*/, LPTSTR lpCmdLine, int /*nShowCmd*/)
{
    lpCmdLine = GetCommandLine(); //this line necessary for _ATL_MIN_CRT
    _Module.Init(ObjectMap, hInstance, IDS_SERVICENAME, &LIBID_REPLICATIONSERVERLib);
    _Module.m_bService = TRUE;

    TCHAR szTokens[] = _T("-/");

    LPCTSTR lpszToken = FindOneOf(lpCmdLine, szTokens);
    while (lpszToken != NULL)
    {
        if (lstrcmpi(lpszToken, _T("UnregServer"))==0)
	        return _Module.UnregisterServer();


        // Register as Local Server
        if (lstrcmpi(lpszToken, _T("RegServer"))==0)
            return _Module.RegisterServer(TRUE, FALSE);
	
        
        // Register as Service
        if (lstrcmpi(lpszToken, _T("Service"))==0)
            return _Module.RegisterServer(TRUE, TRUE);
	
        
        lpszToken = FindOneOf(lpszToken, szTokens);
    }

    // Are we Service or Local Server
    CRegKey keyAppID;
    LONG lRes = keyAppID.Open(HKEY_CLASSES_ROOT, _T("AppID"), KEY_READ);
    if (lRes != ERROR_SUCCESS)
        return lRes;

    CRegKey key;
    lRes = key.Open(keyAppID, _T("{4F98D282-5DE2-4932-BB68-716458EB40C6}"), KEY_READ);
    if (lRes != ERROR_SUCCESS)
        return lRes;

    TCHAR szValue[_MAX_PATH];
    DWORD dwLen = _MAX_PATH;
    lRes = key.QueryValue(szValue, _T("LocalService"), &dwLen);

    _Module.m_bService = FALSE;
    if (lRes == ERROR_SUCCESS)
        _Module.m_bService = TRUE;

    _Module.Start();
 
    // When we get here, the service has been stopped
    return _Module.m_status.dwWin32ExitCode;
}

