// Server.cpp : Implementation of CServer
#include "stdafx.h"
#include "ReplicationServer.h"
#include "Server.h"


void   Log(LPTSTR sz);

/////////////////////////////////////////////////////////////////////////////
// CServer

STDMETHODIMP CServer::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IServer
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (::InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}
void CServer::MyLock()
{
	EnterCriticalSection(&m_cs);
}

void CServer::MyUnlock()
{
	LeaveCriticalSection(&m_cs);
}


//*************************************************************************************************
//andi 
//1 apr 2002
//
//
//*************************************************************************************************
static DWORD WINAPI WorkerThreadProc( LPVOID pParam )
{
	

	SCarry				*pcarry			= (SCarry*)pParam;
	CServer				*pServerObject	= (CServer*)pcarry->pClass;

	//MessageBox(NULL, pcarry->bstrDirectory, pcarry->bstrResourceName,  MB_OK);


	/////////////
	pServerObject->Fire_OnNewResource(pcarry->bstrDirectory, pcarry->bstrResourceName);
	/////////////

	delete pcarry;
    return 0;   // thread completed successfully
}

//*************************************************************************************************
//andi 
//19 apr 2002
//WorkerThreadSyncronize function
//
//*************************************************************************************************
static DWORD WINAPI WorkerThreadSyncronize( LPVOID pParam )
{
	

	SCarry				*pcarry			= (SCarry*)pParam;
	CServer				*pServerObject	= (CServer*)pcarry->pClass;

	//MessageBox(NULL, pcarry->bstrDirectory, pcarry->bstrResourceName,  MB_OK);


	/////////////
	pServerObject->Fire_OnSyncronize();
	/////////////

	delete pcarry;
    return 0;   // thread completed successfully
}

//*************************************************************************************************
//andi 
//19 apr 2002
//WorkerThreadSyncronize function
//
//*************************************************************************************************
static DWORD WINAPI WorkerThreadGetActiveClients( LPVOID pParam )
{
	SCarry				*pcarry			= (SCarry*)pParam;
	CServer				*pServerObject	= (CServer*)pcarry->pClass;

	/////////////
	pServerObject->Fire_OnGetActiveClients();
	/////////////

	delete pcarry;
    return 0;   // thread completed successfully
}

//*************************************************************************************************
//andi 
//19 apr 2002
//PutResource method
//
//*************************************************************************************************
STDMETHODIMP CServer::PutResource(BSTR bstrPathRoot, BSTR bstrDirectory, BSTR bstrResourceName)
{
	// TODO: Add your implementation code here
	
	MACROBEGINTRY
	MyLock();

	_bstr_t				bstrError(L"");

	/////////////
	//if bstrDirectory is not a share on that mashine, make it!!!
	// PathRoot\Directory    ->		\\ServerName\Directory
	//if (m_bShareFirstTime)
	{
		if ( ! _Module.ManageShare(bstrPathRoot, bstrDirectory, &bstrError) )
		{
			RETURN_ERROR((LPTSTR)bstrError);
		}
	
			m_bShareFirstTime			= false;
	}
	/////////////

		//________________________
		//Launch a thread here !!!
		
		SCarry		*pcarry			= new SCarry;
		pcarry->bstrPathRoot		= bstrPathRoot;
		pcarry->bstrDirectory		= bstrDirectory;
		pcarry->bstrResourceName	= bstrResourceName;

		pcarry->pClass			= this;
		
		//create a new thread to made an asyncronous call
		HANDLE hThread = CreateThread(NULL, 0, WorkerThreadProc, pcarry, 0, NULL ); 

		//________________________ 

	MyUnlock();
	MACROENDTRY
}

//*************************************************************************************************
//andi 
//19 apr 2002
//Talk method
//
//*************************************************************************************************
STDMETHODIMP CServer::Talk(long *pVal)
{
	MACROBEGINTRY 
	MyLock();  
 

	if (bServiceRunning)
		*pVal				=  1;
	else
		*pVal				=  0;
	 
	bServiceRunning			= true;

	//TCHAR				sz[10];
	//_ltow( lTalk, sz, 10 );
	//MessageBox(NULL, sz, L"SERVER", MB_OK); 

	


	MyUnlock();
	MACROENDTRY
}

//*************************************************************************************************
//andi 
//19 apr 2002
//Syncronize method
//
//*************************************************************************************************
STDMETHODIMP CServer::Syncronize()
{
		//________________________
		//Launch a thread here !!!
		SCarry		*pcarry			= new SCarry;		
		pcarry->pClass				= this;
		
		//create a new thread to made an asyncronous call
		HANDLE hThread = CreateThread(NULL, 0, WorkerThreadSyncronize, pcarry, 0, NULL ); 
		//________________________ 

	return S_OK;
} 




//#########################################################################
//
//Listen 4 clients
//
//#########################################################################

STDMETHODIMP CServer::GetActiveClients(BSTR *pbstrOut)
{
	_bstr_t							m_bstrClientsList(L" ");
	NAMEVECTOR::iterator			it; 


	m_NameVector.erase(m_NameVector.begin(), m_NameVector.end());

		//________________________
		//Launch a thread here !!!
		SCarry		*pcarry			= new SCarry;	 	
		pcarry->pClass				= this;  
		 
		//create a new thread to made an asyncronous call
		HANDLE hThread = CreateThread(NULL, 0, WorkerThreadGetActiveClients, pcarry, 0, NULL ); 
		//________________________  

	//wait for the clients to respond 
	Sleep(4*1000);
 

	m_bstrClientsList				= L"<root>";

	if (!m_NameVector.empty()) 
		for (it = m_NameVector.begin(); it != m_NameVector.end(); it++)
		{
			m_bstrClientsList		+= L"\r\n";
			m_bstrClientsList		+= L"<client>";
			m_bstrClientsList		+= *it;
			m_bstrClientsList		+= L"</client>";	
			m_bstrClientsList		+= L"\r\n";
	

			m_bstrClientsList		+= L"<server>";
			m_bstrClientsList		+= L"\r\n";
			m_bstrClientsList		+= L"<serveraccount>";
			m_bstrClientsList		+=  _Module.m_szAccountName;
			m_bstrClientsList		+= L"</serveraccount>";	
			m_bstrClientsList		+= L"\r\n";
			m_bstrClientsList		+= L"</server>";
			m_bstrClientsList		+= L"\r\n";
			m_bstrClientsList		+= L"\r\n";
		}

	m_bstrClientsList				+= L"</root>";


	*pbstrOut						= SysAllocString(m_bstrClientsList);

	return S_OK;
}

 


STDMETHODIMP CServer::PutClientName(BSTR bstrIn)
{	
	NAMEVECTOR::iterator			it;
 
	it = find(m_NameVector.begin(), m_NameVector.end(), _bstr_t(bstrIn)) ;

	if (it == m_NameVector.end()) 
	{
		m_NameVector.push_back(bstrIn);
	}
	
	return S_OK;
}
